;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Counter8_1INT.asm
;;   Version: 2.3, Updated on 2004/07/29 at 17:41:18
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Counter8 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Counter8_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _Counter8_1_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; Includes
;------------------------
include "Spim_1.inc"	
include "Scblock_1.inc"
;------------------------
;  Constant Definitions
;------------------------
CONST_FONT: equ 96	;chars in font set
CONST_C: 	equ 16	;chars in string
CONST_L:	equ 3	;lines per pixel
CONST_P: 	equ 8	;vertical pixels per char
CONST_S: 	equ 9	;total strings of text
;------------------------
; Variable Allocation
;------------------------
countF::	BLK	1	;lines per 1st field counter
countC:		BLK	1	;char counter
countL: 	BLK	1	;lines per vertical pixel counter
countP:		BLK	1	;pixels per char counter
countS: 	BLK	1	;text strings counter
ofs: 		BLK	2	;0, N, 2xN, 3xN...  N-chars in font set
ptr: 		BLK	1	;pointer to array for regeneration
ind::		BLK	1	;index var
msb::		BLK	1	;msb of pointer
array::		BLK	144	;array of text
;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _Counter8_1_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_Counter8_1_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)
	push A
	push X

	dec [countF]	;top blank field
	jz next
	mov [countL],CONST_L	;lines per vertical pixel
	mov [countP],CONST_P	;vertical pixels per char
	mov [countS],CONST_S	;total strings of text
	mov [ofs+0],0	;initial offset
	mov [ofs+1],0	;
	mov [ptr],array	;load array pointer
	jnz end
next:
	inc [countF]	;0 is min value


;----------------- TV line generating ------------------
	;M8C_Stall
    or reg[ASY_CR], ASY_CR_SYNCEN
    ;or reg[ASY_CR], 0

	;or  reg[SCBLOCK_1_cr0],0
	or reg[SPIM_1_FUNCTION_REG],0


	mov A, reg[SPIM_1_FUNCTION_REG]
	mov A, reg[SPIM_1_FUNCTION_REG]
	mov A, reg[SPIM_1_FUNCTION_REG]
	mov A, reg[SPIM_1_FUNCTION_REG]
	mov A, reg[SPIM_1_FUNCTION_REG]
	mov A, reg[SPIM_1_FUNCTION_REG]




	;mov [countC],2	;left blank field
	mov reg[SPIM_1_TX_BUFFER_REG],0b00000000;write byte

	w0:	;8+5=13 +8 
	tst reg[SPIM_1_CONTROL_REG], 0b00010000	
	jz w0	;wait for empty (wait bit=1)	
	mov reg[SPIM_1_TX_BUFFER_REG],0b00000000;write byte
	;dec [countC]
	;jnz w0

	mov [countC],CONST_C ;chars per string
	w1:	
	mvi A, [ptr]	;10
	add A, [ofs+0]	;6
	mov X,A			;4	
	mov A, (>font)	;4
	adc A, [ofs+1]	;6
	romx			;11
	;nop
	mov X, [ofs+1]	;6
	;nop
	;nop

	mov reg[SPIM_1_TX_BUFFER_REG],A;write byte	;5
	dec [countC]								;7
	jnz w1										;5
;------------------------------------------------------
	sub [ptr],CONST_C	;
	dec [countL]
	jnz end

	mov [countL],CONST_L	;lines per vertical pixel
	add [ofs+0], CONST_FONT	;next offset
	adc [ofs+1],0	;
	dec [countP]
	jnz end

	mov [ofs+0],0	;initial offset again
	mov [ofs+1],0	;
	mov [countP],CONST_P	;vertical pixels per char
	add [ptr],CONST_C	;
	dec [countS]
	jnz end

	mov [countF],254 ;bottom is blank

end:pop X
	pop A
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file Counter8_1INT.asm
