;-----------------------------------------------------------------------------
; TV PAL generating
; 154 x 10/22 us per string
; 624 strings, non-interlaced
;-----------------------------------------------------------------------------
;
;

include "m8c.inc"       ; part specific constants and macros
include "memory.inc"    ; Constants & macros for SMM/LMM and Compiler
include "PSoCAPI.inc"   ; PSoC API definitions for all User Modules

export _main
;-------------------------------------------------------------------
macro print_string ;@0,@1,@2
;Usage: print_string row,col,"string" (row,col=0,1...)
	;row*16+col+array -> [ind]
	mov A,@0
	asl A 
	asl A 
	asl A 
	asl A 
	add A,@1
	add A,array
	mov [ind],A
	;load addr in ROM	
	mov [msb],>string
	mov	X,<string
	rep:
	mov A,[msb]
	romx
	jz end

	mvi [ind],A
	inc X
	adc [msb],0
	jmp rep

	.LITERAL
	string:
	DS @2
	DB 00h
	.ENDLITERAL
	end:
endm
;-------------------------------------------------------------------
_main:

	print_string 0,0,"Hitachi 16x2 LCD"
	print_string 1,0,"      must died!"
	print_string 2,0,"                "
	print_string 3,0,"TV monitor      "
	print_string 4,0,"        forever!"
	print_string 5,0,"                "
	print_string 6,0,"1234567812345678"
	print_string 7,0,""
	print_string 8,0,"||||||||"

	;start UM
	mov A, SPIM_1_SPIM_MODE_0 | SPIM_1_SPIM_MSB_FIRST
	lcall SPIM_1_Start
	lcall Counter8_1_Start
	lcall Counter16_1_Start


	mov [countF],50 ;top blank field
	;enable inerrupts
	lcall Counter8_1_EnableInt
	lcall Counter16_1_EnableInt
    M8C_EnableGInt

	
.terminate:
    jmp .terminate
